// src/hook.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

// The idea of this file is to provide a static function to execute
// when the plugin (this library) is loaded. Thus the name "hook".

// For the moment, instead of a function hook to be called by the 
// libbackend.so module, we have a static PythonPolicyManager object.
// This is a risk.
#warning FIXME : this code is quite a bad idea. Replace me with \
  a hookable structure, and execute a pointer to function stored \
  therein. See "info libtool": "dlopened modules"

#ifdef __cplusplus
extern "C" {
#endif

#include "config.h"

#define SG_CONSTRUCTOR __attribute__ ((constructor))
#define SG_DESTRUCTOR __attribute__ ((destructor))

void SG_DLLEXPORT SG_CONSTRUCTOR hook_ctor(void) 
{
}

void SG_DLLEXPORT SG_DESTRUCTOR hook_dtor(void) 
{
}

#ifdef  __cplusplus
}
#endif
